use std::fs::File;

use crate::{targets::Target, validator::predefined::TypeType};

pub struct LuaGen;

impl Target for LuaGen {
    fn new() -> Self where Self: Sized {
        Self
    }
    fn get_target_triple() -> &'static str {
        "none-luagen-cct"
    }
    fn get_int_ext(&self) -> &'static str {
        "lua"
    }
    fn write_code(&mut self, program: &crate::parser::ast::Program, f: &mut File) -> anyhow::Result<()> {
        Ok(())
    }
    fn compile(&mut self, _from: &std::path::Path, _to: &std::path::Path) -> anyhow::Result<()> {
        Ok(())
    }
    fn link(&mut self, _from: Vec<std::path::PathBuf>, _to: &std::path::Path) -> anyhow::Result<()> {
        Ok(())
    }
}
