

int main();

static char** __INTERNALS__ARGV_PTR = 0;
static int __INTERNALS__ARGC = 0;

__attribute__((noreturn))
void _start() {
    long *stack = (long *) __builtin_frame_address(0);
    __INTERNALS__ARGC     = stack[0];
    __INTERNALS__ARGV_PTR = (char **) &stack[1];

    int exit_code = main();
    __asm__ volatile (
        "syscall\n"
        :: "a" (60), "D" (exit_code)
        : 
    );

    __builtin_unreachable();
}

unsigned long long syscall(unsigned char arg_count, unsigned char sc_num, void *const *const args) {
    register long long ret;

    switch (arg_count) {
        case 6:
            __asm__ volatile ("mov 40(%0), %%r9" :: "r"(args) : "r9");
        case 5:
            __asm__ volatile ("mov 32(%0), %%r8" :: "r"(args) : "r8");
        case 4:
            __asm__ volatile ("mov 24(%0), %%r10" :: "r"(args) : "r10");
        case 3:
            __asm__ volatile ("mov 16(%0), %%rdx" :: "r"(args) : "rdx");
        case 2:
            __asm__ volatile ("mov 8(%0), %%rsi" :: "r"(args) : "rsi");
        case 1:
            __asm__ volatile (
                "mov (%0), %%rdi\n"
                "syscall"
                : "=a"(ret)
                : "r"(args), "a"(sc_num)
                : "rdi", "rsi", "rdx", "r10", "r8", "r9", "rcx", "r11", "memory"
            );
            return ret;
        default:
            return -1;
    }
}
