use std::fs::File;


use llvm_lib::core::module;

use crate::targets::Target;

// https://github.com/TheDan64/inkwell/blob/master/examples/kaleidoscope/implementation_typed_pointers.rs
pub struct LlvmGen {

}

impl Target for LlvmGen {
    fn new() -> Self where Self: Sized {
        Self {

        }
    }
    fn get_target_triple() -> &'static str {
        "x86_64-llvm-linux"
    }
    fn get_int_ext(&self) -> &'static str {
        ""
    }
    fn write_code(&mut self, _program: &crate::parser::ast::Program, _ofp: &mut File) -> anyhow::Result<()> {
        let mdl = module::ModuleRef::new("main");

        Ok(())
    }
    fn compile(&mut self, _from: &std::path::Path, _to: &std::path::Path) -> anyhow::Result<()> {
        Ok(())
    }
    fn link(&mut self, _from: Vec<std::path::PathBuf>, _to: &std::path::Path) -> anyhow::Result<()> {
        Ok(())
    }
} 
